;
; < ----------------------- >
;   PureBasic IDE - RunOnce 
; < ----------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

Procedure$ CheckSpecialCommands(HelpDirectory$,Topic$)

  Select UCase(Topic$)
    Case "SIZEOF":   Topic$ = "Reference/"+"others" : HelpDirectory$ = ""
    Case "OFFSETOF": Topic$ = "Reference/"+"others" : HelpDirectory$ = ""
    
    Default : Topic$ = "/"+Topic$
  EndSelect

  ProcedureReturn HelpDirectory$+Topic$

EndProcedure


Procedure$ CheckPureBasicKeyWords(Topic$)

   Select UCase(GetCurrentWord())
     Case "FOR"                  : Topic$ = "Reference/"+"for_next.html"
     Case "TO"                   : Topic$ = "Reference/"+"for_next.html"
     Case "STEP"                 : Topic$ = "Reference/"+"for_next.html"
     Case "NEXT"                 : Topic$ = "Reference/"+"for_next.html"

     Case "FOREACH"              : Topic$ = "Reference/"+"foreach_next.html"     

     Case "GOSUB"                : Topic$ = "Reference/"+"gosub_return.html"
     Case "RETURN"               : Topic$ = "Reference/"+"gosub_return.html"
     Case "FAKERETURN"           : Topic$ = "Reference/"+"gosub_return.html"

     Case "IF"                   : Topic$ = "Reference/"+"if_endif.html"
     Case "ELSEIF"               : Topic$ = "Reference/"+"if_endif.html"
     Case "ELSE"                 : Topic$ = "Reference/"+"if_endif.html"
     Case "ENDIF"                : Topic$ = "Reference/"+"if_endif.html"

     Case "REPEAT"               : Topic$ = "Reference/"+"repeat_until.html"
     Case "UNTIL"                : Topic$ = "Reference/"+"repeat_until.html"
     Case "FOREVER"              : Topic$ = "Reference/"+"repeat_until.html"

     Case "SELECT"               : Topic$ = "Reference/"+"select_endselect.html"
     Case "CASE"                 : Topic$ = "Reference/"+"select_endselect.html"
     Case "DEFAULT"              : Topic$ = "Reference/"+"select_endselect.html"
     Case "ENDSELECT"            : Topic$ = "Reference/"+"select_endselect.html"
     Case "FAKEENDSELECT"        : Topic$ = "Reference/"+"select_endselect.html"

     Case "WHILE"                : Topic$ = "Reference/"+"while_wend.html"
     Case "WEND"                 : Topic$ = "Reference/"+"while_wend.html"
     
     Case "GOTO"                 : Topic$ = "Reference/"+"others.html"
     Case "END"                  : Topic$ = "Reference/"+"others.html"
     
     Case "DEFTYPE"              : Topic$ = "Reference/"+"deftype.html"
     
     Case "DIM"                  : Topic$ = "Reference/"+"dim.html"
     
     Case "NEWLIST"              : Topic$ = "Reference/"+"newlist.html"
     
     Case "STRUCTURE"            : Topic$ = "Reference/"+"structures.html"
     Case "STRUCTUREUNION"       : Topic$ = "Reference/"+"structures.html"
     Case "ENDSTRUCTUREUNION"    : Topic$ = "Reference/"+"structures.html"
     Case "ENDSTRUCTURE"         : Topic$ = "Reference/"+"structures.html"

     Case "INTERFACE"            : Topic$ = "Reference/"+"interfaces.html"
     Case "ENDINTERFACE"         : Topic$ = "Reference/"+"interfaces.html"
     Case "EXTENDS"              : Topic$ = "Reference/"+"interfaces.html"
     
     Case "ENUMERATION"          : Topic$ = "Reference/"+"enumerations.html"
     Case "ENDENUMERATION"       : Topic$ = "Reference/"+"enumerations.html"

     Case "BREAK"                : Topic$ = "Reference/"+"break_continue.html"
     Case "CONTINUE"             : Topic$ = "Reference/"+"break_continue.html"
     
     Case "GLOBAL"               : Topic$ = "Reference/"+"global.html"

     Case "PROCEDURE"            : Topic$ = "Reference/"+"procedures.html"
     Case "ENDPROCEDURE"         : Topic$ = "Reference/"+"procedures.html"
     Case "PROCEDURERETURN"      : Topic$ = "Reference/"+"procedures.html"
     Case "DECLARE"              : Topic$ = "Reference/"+"procedures.html"

     Case "PROCEDUREDLL"         : Topic$ = "Reference/"+"dll.html"
     Case "PROCEDURECDLL"        : Topic$ = "Reference/"+"dll.html"
     Case "DECLAREDLL"           : Topic$ = "Reference/"+"dll.html"
     Case "DECLARECDLL"          : Topic$ = "Reference/"+"dll.html"
     
     Case "SHARED"               : Topic$ = "Reference/"+"shared.html"

     Case "STATIC"               : Topic$ = "Reference/"+"static.html"
    
     Case "PROTECTED"            : Topic$ = "Reference/"+"protected.html"
     
     Case "DATASECTION"          : Topic$ = "Reference/"+"data.html"
     Case "ENDDATASECTION"       : Topic$ = "Reference/"+"data.html"
     Case "DATA"                 : Topic$ = "Reference/"+"data.html"
     Case "RESTORE"              : Topic$ = "Reference/"+"data.html"
     Case "READ"                 : Topic$ = "Reference/"+"data.html"

     Case "CALLDEBUGGER"         : Topic$ = "Reference/"+"debugger.html"
     Case "DEBUG"                : Topic$ = "Reference/"+"debugger.html"
     Case "DEBUGLEVEL"           : Topic$ = "Reference/"+"debugger.html"
     Case "DISABLEDEBUGGER"      : Topic$ = "Reference/"+"debugger.html"
     Case "ENABLEDEBUGGER"       : Topic$ = "Reference/"+"debugger.html"

     Case "INCLUDEFILE"          : Topic$ = "Reference/"+"includes.html"
     Case "XINCLUDEFILE"         : Topic$ = "Reference/"+"includes.html"
     Case "INCLUDEBINARY"        : Topic$ = "Reference/"+"includes.html"
     Case "INCLUDEPATH"          : Topic$ = "Reference/"+"includes.html"

     Case "COMPILERIF"           : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERELSE"         : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERENDIF"        : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERSELECT"       : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERCASE"         : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERDEFAULT"      : Topic$ = "Reference/"+"compilerdirectives.html"
     Case "COMPILERENDSELECT"    : Topic$ = "Reference/"+"compilerdirectives.html"

     Default : Topic$ = ""
   EndSelect

   ProcedureReturn Topic$
EndProcedure

;
;   THIS IS TO TEST THE COMMANDS!
;      (press F1 on command)
;
#CheckPureBasicKeyWords = 0
CompilerIf #CheckPureBasicKeyWords = 1

;
; PureBasic special library commands
;
SizeOf()
OffsetOf()

;
; PureBasic Keywords
;
For  To  Step  Next

ForEach

Gosub  Return  FakeReturn

If  ElseIf  Else  EndIf

Repeat  Until  ForEver

Break Continue

Select  Case  Default  EndSelect  FakeEndSelect

While  Wend

Goto

DefType DefType.s DefType$ DefType.l

Dim

NewList

Structure  EndStructure  StructureUnion  EndStructureUnion

Interface EndInterface Extends

Enumeration EndEnumeration

Global

Procedure  ProcedureDLL  EndProcedure  ProcedureReturn  Declare  Declare$  Declare.l ProcedureCDLL DeclareCDLL DeclareDLL

Shared

Protected

DataSection  EndDataSection  Data Data$ Data.l  Restore  Read

CallDebugger  Debug  DebugLevel  DisableDebugger  EnableDebugger

IncludeFile  XIncludeFile  IncludeBinary  IncludePath

; DONT UNCOMMENT THIS OR DOESNT COMPILE (special compiler commands)!
;
; CompilerSelect  CompilerCase  CompilerDefault  CompilerEndSelect
; CompilerIf  CompilerElse  CompilerEndIf

CompilerEndIf 
; ExecutableFormat=Windows
; EOF