;
; < ---------------------------- >
;   PureBasic IDE - Find/Replace 
; < ---------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2005 Fantaisie Software
;


XIncludeFile "Common.pb"

#WINDOW_Find_Height = 140
#WINDOW_Find_Width  = 405


Procedure FindTextNext(Mode)
  
  If GlobalFindText$ <> ""
    Flags = #FR_DOWN  ; Don't worry, it's ignored on RICHEDIT 1.0
    
    SendMessage_(*RichEditGadget, #EM_GETSEL, @CurrentCursorPosition, 0)
    StringToSearch\chrg\cpMin = CurrentCursorPosition
    StringToSearch\chrg\cpMax = GetWindowTextLength_(*RichEditGadget)
    StringToSearch\lpstrText  = @GlobalFindText$
    
    If GlobalFindFlags & #FIND_MatchCase : Flags | #FR_MATCHCASE : EndIf
    If GlobalFindFlags & #FIND_WholeWord : Flags | #FR_WHOLEWORD : EndIf
    
    If Mode = 3
      Mode = 0
      StringToSearch\chrg\cpMin+1
    EndIf
    
    If SendMessage_(*RichEditGadget, #EM_FINDTEXTEX, Flags, StringToSearch) <> -1
      Result = 1
      
      Select Mode
          
        Case 0: ; Find
          ChangeActiveLine(SendMessage_(*RichEditGadget, #EM_EXLINEFROMCHAR, 0, StringToSearch\chrgText\cpMin), -3)
          SendMessage_(*RichEditGadget, #EM_SETSEL, StringToSearch\chrgText\cpMin, StringToSearch\chrgText\cpMax)
          
        Case 1: ; Replace
          SendMessage_(*RichEditGadget, #EM_SETSEL, StringToSearch\chrgText\cpMin, StringToSearch\chrgText\cpMax)
          SendMessage_(*RichEditGadget, #EM_REPLACESEL, 1, GlobalReplaceText$)
          FindTextNext(3)
          
        Case 2: ; Replace All
          While SendMessage_(*RichEditGadget, #EM_FINDTEXTEX, Flags, StringToSearch) <> -1
            
            SendMessage_(*RichEditGadget, #EM_SETSEL, StringToSearch\chrgText\cpMin, StringToSearch\chrgText\cpMax)
            SendMessage_(*RichEditGadget, #EM_REPLACESEL, 1, GlobalReplaceText$)
            
            StringToSearch\chrg\cpMax = GetWindowTextLength_(*RichEditGadget)
            StringToSearch\chrg\cpMin = StringToSearch\chrgText\cpMin+Len(GlobalReplaceText$)
          Wend
      EndSelect
      
    Else
      MessageRequester("Find/Replace", "No more entry found.", #MB_OK | #MB_ICONINFORMATION)
    EndIf
  EndIf
  
  ProcedureReturn Result
EndProcedure


Procedure UpdateDisableState(State)

  DisableGadget(#GADGET_Find_ReplaceWord, 1-State)
  DisableGadget(#GADGET_Find_ReplaceAll , 1-State)
  DisableGadget(#GADGET_Find_Replace    , 1-State)

EndProcedure


Procedure RefreshFindParameters()
  
  GlobalFindText$    = GetGadgetText (#GADGET_Find_FindWord)
  GlobalReplaceText$ = GetGadgetText (#GADGET_Find_ReplaceWord)
  GlobalFindFlags    = GetGadgetState(#GADGET_Find_EnableWholeWord) | GetGadgetState(#GADGET_Find_EnableMatchCase) << 1
    
EndProcedure


Procedure UpdateFindComboBox(GadgetID) ; Works the same for find & replace combo

  Text$ = GetGadgetText(GadgetID)
  
  If Text$
    For k=1 To CountGadgetItems(GadgetID)
      If GetGadgetItemText(GadgetID, k-1, 0) = Text$
        RemoveGadgetItem(GadgetID, k-1)
        Break
      EndIf
    Next
    
    AddGadgetItem(GadgetID, 0, Text$) ; Insert at the top of the list
  EndIf
  
EndProcedure


Procedure OpenFindWindow(State)

  If IsFindWindow  ; If the window has been opened once, open it again (it allows to keep all parameters easily)
    HideWindow(#WINDOW_Find, #False)

  ElseIf OpenWindow(#WINDOW_Find, 0, 0, #WINDOW_Find_Width, #WINDOW_Find_Height, #PB_Window_SystemMenu | #PB_Window_WindowCentered | #PB_Window_Invisible, Langage(72), WindowID(#WINDOW_Main))

    Left = 10 : Top = 10
    CreateGadgetList(WindowID(#WINDOW_Find))
      TextGadget    (#GADGET_Find_Label1  , Left, Top+2, 90                        , 18, Langage(73), #PB_Text_Right) : Left + 100  ; "Find :"
      ComboBoxGadget(#GADGET_Find_FindWord, Left, Top  , #WINDOW_Find_Width-Left-10, 400, #PB_ComboBox_Editable|#CBS_AUTOHSCROLL) : Left = 10 : Top + 30
      SendMessage_  (GadgetID(#GADGET_Find_FindWord), #CB_LIMITTEXT, 0, 0) ; remove text limit (#CBS_AUTOHSCROLL flag needs to be set on the gadget)
      
      CheckBoxGadget(#GADGET_Find_EnableReplace, Left, Top+2, 90                        , 18, Langage(74), #PB_CheckBox_Right) : Left + 100 ; "Replace with :"
      ComboBoxGadget(#GADGET_Find_ReplaceWord  , Left, Top  , #WINDOW_Find_Width-Left-10, 400, #PB_ComboBox_Editable|#CBS_AUTOHSCROLL) : Top + 30
      SendMessage_  (GadgetID(#GADGET_Find_ReplaceWord), #CB_LIMITTEXT, 0, 0) ; remove text limit (#CBS_AUTOHSCROLL flag needs to be set on the gadget)
      
      CheckBoxGadget(#GADGET_Find_EnableWholeWord, Left, Top+2, 140, 18, Langage(75)) : Left + 150 ; "Whole word only"
      CheckBoxGadget(#GADGET_Find_EnableMatchCase, Left, Top+2, 140, 18, Langage(76)) : Top + 35   ; "Match case"

      ButtonWidth = #WINDOW_Find_Width/4
      
      ButtonGadget (#GADGET_Find_Cancel    ,    ButtonWidth*3, Top, ButtonWidth-10, 25, Langage(77))  ; "Cancel"
      ButtonGadget (#GADGET_Find_ReplaceAll,  4+ButtonWidth*2, Top, ButtonWidth-10, 25, Langage(78))  ; "Replace All"
      ButtonGadget (#GADGET_Find_Replace   ,  8+ButtonWidth  , Top, ButtonWidth-10, 25, Langage(79))  ; "Replace"
      ButtonGadget (#GADGET_Find_Next      , 10              , Top, ButtonWidth-10, 25, Langage(80), #PB_Button_Default)  ; "Next"

    AddKeyboardShortcut(#WINDOW_Find, #PB_Shortcut_F3    , #GADGET_Find_Next)
    AddKeyboardShortcut(#WINDOW_Find, #PB_Shortcut_Return, #GADGET_Find_Next)
    AddKeyboardShortcut(#WINDOW_Find, #PB_Shortcut_Escape, #GADGET_Find_Cancel)
    
    SetGadgetState(#GADGET_Find_EnableReplace, State)
    UpdateDisableState(State)
    
    HideWindow(#WINDOW_Find, 0)
    
    IsFindWindow = #True
  EndIf
  
  SendMessage_(GadgetID(#GADGET_Find_FindWord), #EM_SETSEL, 0, -1) ; Selects the whole text, so it's easily replaced
  ActivateGadget(#GADGET_Find_FindWord)
  
EndProcedure


Procedure FindWindowEvents(EventID)

  If EventID = #PB_Event_Menu     ; Little wrapper to map the shortcut events (identified as menu)
    EventID  = #PB_Event_Gadget   ; to normal gadget events...
    GadgetID = EventMenuID()
  Else
    GadgetID = EventGadgetID()
  EndIf

  Select EventID
    Case #PB_Event_CloseWindow
      Quit = 1
  
    Case #PB_Event_Gadget
      Select GadgetID
      
        Case #GADGET_Find_EnableReplace
          UpdateDisableState(GetGadgetState(#GADGET_Find_EnableReplace))
        
        Case #GADGET_Find_Next
          RefreshFindParameters()
          UpdateFindComboBox(#Gadget_Find_FindWord)
          UpdateFindComboBox(#Gadget_Find_ReplaceWord)
          FindTextNext(3)       ; Don't close the window..
                    
        Case #GADGET_Find_Replace
          RefreshFindParameters()
          FindTextNext(1)    ; Don't close the window..

        Case #GADGET_Find_ReplaceAll
          RefreshFindParameters()
          If FindTextNext(2) : Quit = 1 : EndIf
        
        Case #GADGET_Find_Cancel
          Quit = 1
      
      EndSelect
          
  EndSelect
  
  If Quit 
    HideWindow(#WINDOW_Find, #True)
    UseWindow(#WINDOW_Main)
  EndIf
  
EndProcedure

; Test line...
; 
;OpenWindow(0, 100, 100, 800, 400, #PB_Window_SystemMenu, "") : OpenFindWindow(0) : Repeat : FindWIndowEvents(WaitWindowEvent()) : ForEver
; ExecutableFormat=Windows
; EOF