;
; < ------------------------------- >
;   PureBasic IDE - CompilerOptions 
; < ------------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

XIncludeFile "Common.pb"

Procedure OpenOptionWindow()

  If OpenWindow(#WINDOW_Option, 0, 0, 350, 250, #PB_Window_SystemMenu | #PB_Window_WindowCentered | #PB_Window_Invisible, Langage(41), WindowID(#WINDOW_Main))

    Top = 10
    If CreateGadgetList(WindowID(#WINDOW_Option))
      CheckBoxGadget(#GADGET_Option_UseMainFile   ,  10, Top,  95, 20, Langage(190))  ; "Main file: "
      StringGadget  (#GADGET_Option_MainFile      , 110, Top, 195, 20, FileList()\MainFile$)
      ButtonGadget  (#GADGET_Option_SelectMainFile, 310, Top,  30, 20, "...") : Top+25

      CheckBoxGadget(#GADGET_Option_UseIcon   ,  10, Top,  95, 20, Langage(42))  ; "Use Icon: "
      StringGadget  (#GADGET_Option_IconName  , 110, Top, 195, 20, FileList()\IconName$)
      ButtonGadget  (#GADGET_Option_SelectIcon, 310, Top,  30, 20, "...") : Top+25

      CheckBoxGadget(#GADGET_Option_EnableASM    ,  10, Top, 300, 20, Langage(43)) : Top+25  ;  "EnableASM"
      CheckBoxGadget(#GADGET_Option_EnableNT4    ,  10, Top, 300, 20, Langage(44)) : Top+25  ;  "Enable NT4"
      CheckBoxGadget(#GADGET_Option_EnableXP     ,  10, Top, 300, 20, Langage(71)) : Top+25  ;  "Enable XP"
      CheckBoxGadget(#GADGET_Option_EnableOnError,  10, Top, 300, 20, Langage(199)) : Top+25  ; "Enable OnError lines support"

      TextGadget    (#PB_Any, 10, Top+3, 300, 20, Langage(70)) ;  "Executable format:"
      ComboBoxGadget(#GADGET_Option_ExecutableFormat, 120, Top,  100, 200)
        AddGadgetItem(#GADGET_Option_ExecutableFormat, -1, "Windows")
        AddGadgetItem(#GADGET_Option_ExecutableFormat, -1, "Console")
        AddGadgetItem(#GADGET_Option_ExecutableFormat, -1, "Shared Dll")
        SetGadgetText(#GADGET_Option_ExecutableFormat, FileList()\ExecutableFormat$)

      ComboBoxGadget(#GADGET_Option_CPU, 230, Top,  110, 200) : Top+25
        AddGadgetItem(#GADGET_Option_CPU, -1, "All CPU")
        AddGadgetItem(#GADGET_Option_CPU, -1, "Dynamic CPU")
        AddGadgetItem(#GADGET_Option_CPU, -1, "CPU with MMX")
        AddGadgetItem(#GADGET_Option_CPU, -1, "CPU with 3DNOW")
        AddGadgetItem(#GADGET_Option_CPU, -1, "CPU with SSE")
        AddGadgetItem(#GADGET_Option_CPU, -1, "CPU with SSE2")
        SetGadgetState(#GADGET_Option_CPU, FileList()\CPU)
      
      TextGadget  (#PB_Any, 10, Top+3, 300, 20, langage(81)) ; "Command Line:"
      StringGadget(#GADGET_Option_CommandLine, 120, Top,  220, 20, FileList()\CommandLine$) : Top+33
      
      ButtonGadget(#GADGET_Option_Cancel, 180, Top, 160, 25, Langage(45))
      ButtonGadget(#GADGET_Option_Ok    ,  10, Top, 158, 25, Langage(46), #PB_Button_Default)

      ; Need to be before the mass gadget disabling
      ;      
      DisableGadget (#GADGET_Option_IconName  , 1-FileList()\UseIcon)
      DisableGadget (#GADGET_Option_SelectIcon, 1-FileList()\UseIcon)

      ; Mass gadget disabling depending of the UseMainFile value
      ;
      DisableGadget(#GADGET_Option_MainFile      , 1-FileList()\UseMainFile)
      DisableGadget(#GADGET_Option_SelectMainFile, 1-FileList()\UseMainFile)
          
      For k = #GADGET_Option_UseIcon To #GADGET_Option_CPU
        DisableGadget(k, FileList()\UseMainFile)
      Next

      SetGadgetState(#GADGET_Option_UseMainFile  , FileList()\UseMainFile)
      SetGadgetState(#GADGET_Option_UseIcon      , FileList()\UseIcon)
      SetGadgetState(#GADGET_Option_EnableASM    , FileList()\EnableASM)
      SetGadgetState(#GADGET_Option_EnableNT4    , FileList()\EnableNT4)
      SetGadgetState(#GADGET_Option_EnableXP     , FileList()\EnableXP)
      SetGadgetState(#GADGET_Option_EnableOnError, FileList()\EnableOnError)
    EndIf
    
    AddKeyboardShortcut(#WINDOW_Option, #PB_Shortcut_Return, #GADGET_Option_Ok)
    AddKeyboardShortcut(#WINDOW_Option, #PB_Shortcut_Escape, #GADGET_Option_Cancel)
    
    HideWindow(#WINDOW_Option, 0)
  EndIf

EndProcedure


Procedure OptionWindowEvents(EventID)

  If EventID = #PB_Event_Menu     ; Little wrapper to map the shortcut events (identified as menu)
    EventID  = #PB_Event_Gadget   ; to normal gadget events...
    GadgetID = EventMenuID()
  Else
    GadgetID = EventGadgetID()
  EndIf

  Select EventID
    Case #PB_EventCloseWindow
      Quit = 1
   
    Case #PB_EventGadget
    
      Select GadgetID

        Case #GADGET_Option_Ok
        
          EnableASM = FileList()\EnableASM
        
          FileList()\EnableASM = GetGadgetState(#GADGET_Option_EnableASM) 
          
          If EnableASM <> FileList()\EnableASM ; We have to enable the syntax highlightning if the config change
            UpdateTextHighlightning(EnableColoring, 0, 0)
          EndIf
        
          FileList()\UseMainFile    = GetGadgetState(#GADGET_Option_UseMainFile)
          FileList()\UseIcon        = GetGadgetState(#GADGET_Option_UseIcon)
          FileList()\EnableNT4      = GetGadgetState(#GADGET_Option_EnableNT4)
          FileList()\EnableXP       = GetGadgetState(#GADGET_Option_EnableXP)
          FileList()\EnableOnError  = GetGadgetState(#GADGET_Option_EnableOnError)
          FileList()\CPU            = GetGadgetState(#GADGET_Option_CPU)
                                        
          If FileList()\UseIcon
            FileList()\IconName$ = GetGadgetText(#GADGET_Option_IconName)
          EndIf

          If FileList()\UseMainFile
            FileList()\MainFile$ = GetGadgetText(#GADGET_Option_MainFile)
          EndIf

          FileList()\ExecutableFormat$ = GetGadgetText(#GADGET_Option_ExecutableFormat)
          FileList()\CommandLine$      = GetGadgetText(#GADGET_Option_CommandLine)

          Quit = 1
           
        Case #GADGET_Option_Cancel
          Quit = 1

        Case #GADGET_Option_UseMainFile
          Result = GetGadgetState(#GADGET_Option_UseMainFile)

          DisableGadget(#GADGET_Option_MainFile      , 1-Result)
          DisableGadget(#GADGET_Option_SelectMainFile, 1-Result)
          
          For k = #GADGET_Option_UseIcon To #GADGET_Option_CPU
            DisableGadget(k, Result)
          Next
          

        Case #GADGET_Option_SelectMainFile
          File$ = OpenFileRequester("", "", "PureBasic files (*.pb, *.pbi)|*.pb;*.pbi|All (*.*)|*.*", 0)
          If File$
            SetGadgetText(#GADGET_Option_MainFile, File$)
          EndIf


        Case #GADGET_Option_UseIcon
          Result = GetGadgetState(#GADGET_Option_UseIcon)

          DisableGadget(#GADGET_Option_IconName  , 1-Result)
          DisableGadget(#GADGET_Option_SelectIcon, 1-Result)
          
        Case #GADGET_Option_SelectIcon
          File$ = OpenFileRequester("", "", "Icon files (*.ico)|*.ico|All (*.*)|*.*", 0)
          If File$
            SetGadgetText(#GADGET_Option_IconName, File$)
          EndIf
          
      EndSelect
  EndSelect
  
  If Quit = 1
    CloseWindow(#WINDOW_Option)
    UseWindow(#WINDOW_Main)
  EndIf
  
EndProcedure


; OpenWindow(0, 100, 100, 800, 400, #PB_Window_SystemMenu, "") : OpenOptionWindow() : Repeat : OptionWindowEvents(WaitWindowEvent()) : ForEver
; ExecutableFormat=Windows
; UseMainFile=Purebasic Ide.pb
; EOF