;
; < ----------------------- >
;   PureBasic IDE - RunOnce 
; < ----------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;


#ERROR_ALREADY_EXISTS = $B7

Procedure RunOnce(name.s)

  If Editor_RunOnce
    Editor_RunOnceMessage = RegisterWindowMessage_("PB_Editor_RuneOnce")
    Editor_RunOnceMutex   = CreateMutex_(0,0,"PureBasic_Editor")
    
    If GetLastError_() = #ERROR_ALREADY_EXISTS
      If GetVersion_() & $ff0000  ; Windows NT/XP
        x = RegCreateKeyEx_(#HKEY_CLASSES_ROOT, "Applications\PureBasic.exe\", 0, 0, #REG_OPTION_NON_VOLATILE, #KEY_ALL_ACCESS, 0, @NewKey, @KeyInfo)
      Else  ; The same for Win9x
        x = RegCreateKeyEx_(#HKEY_LOCAL_MACHINE, "Software\Classes\PureBasic.exe\", 0, 0, #REG_OPTION_NON_VOLATILE, #KEY_ALL_ACCESS, 0, @NewKey, @KeyInfo)
      EndIf
      
      If x = #ERROR_SUCCESS
         RegSetValueEx_(NewKey, "RunOnce_FileName", 0, #REG_SZ,  name, Len(name)+1)
         RegCloseKey_(NewKey)
         SendMessage_(#HWND_BROADCAST, Editor_RunOnceMessage, "OPENFILE", 0)
         End
      EndIf
    EndIf
  EndIf
EndProcedure


Procedure RunOnce_Message()

  If GetVersion_() & $ff0000  ; Windows NT/XP
    x = RegOpenKeyEx_(#HKEY_CLASSES_ROOT, "Applications\PureBasic.exe\",0,#KEY_ALL_ACCESS, @NewKey)
  Else  ; The same for Win9x
    x = RegOpenKeyEx_(#HKEY_LOCAL_MACHINE, "Software\Classes\PureBasic.exe\", 0, #KEY_ALL_ACCESS, @NewKey)
  EndIf
  
  If x = #ERROR_SUCCESS

     A$ = Space(2000) : ASize = 2000
     RegQueryValueEx_(NewKey, "RunOnce_FileName", 0, 0,  @A$, @ASize)
     RegSetValueEx_(NewKey, "RunOnce_FileName", 0, #REG_SZ,  "", 1)
     RegCloseKey_(NewKey)

     If A$ <> ""
        LoadSourceCodeReal( A$, 0 )
     EndIf
     SetForegroundWindow_(WindowID(#WINDOW_Main))
     EnableWindow_(WindowID(#WINDOW_Main),#TRUE)
     If IsWindowMaximized
        ShowWindow_(*MainWindow, #SW_MAXIMIZE)
     Else
        ShowWindow_(*MainWindow, #SW_RESTORE)
     EndIf
  EndIf
EndProcedure
; ExecutableFormat=Windows
; EOF