;
; < ---------------------- >
;   PureBasic IDE - Common 
; < ---------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

; Comment/UnComment by Danilo, 20.01.2003

NewList CommentSelectionLine.s()

Procedure CommentSelection()
  If *RichEditGadget
    SendMessage_(*RichEditGadget,#EM_EXGETSEL,0,selrange.CHARRANGE)
    If selrange\cpMin <> selrange\cpMax
       SendMessage_(*RichEditGadget, #WM_SETREDRAW, #False, 0) ; Disable the redraw on the RichEdit for clean effect

       StartLine   = SendMessage_(*RichEditGadget,#EM_EXLINEFROMCHAR,0,selrange\cpMin)
       EndLine     = SendMessage_(*RichEditGadget,#EM_EXLINEFROMCHAR,0,selrange\cpMax-1) ; -1 = fix, dont remove
       
       ;ClearList(CommentSelectionLine())
       For a = StartLine To EndLine
          *buffer.Byte = GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,64000)
          PokeW(*buffer,64000)
          Length = SendMessage_(*RichEditGadget,#EM_GETLINE,a,*buffer)
          PokeL(*buffer+length,0)
          AddElement(CommentSelectionLine())
          A$ = PeekS(*buffer,64000)
          ;B$ = Trim(A$)
          ;If Len(B$) = 1 And (PeekB(@B$) = 11 Or PeekB(@B$) = 10 Or PeekB(@B$) = 13)
          ;   CommentSelectionLine() = A$
          ;Else
             CommentSelectionLine() = "; "+A$
          ;EndIf
          
          GlobalFree_(*buffer)
       Next a

       range.CHARRANGE
       range\cpMin = SendMessage_(*RichEditGadget,#EM_LINEINDEX,StartLine,0)
       x = SendMessage_(*RichEditGadget,#EM_LINEINDEX,EndLine,0)
       y = SendMessage_(*RichEditGadget,#EM_LINELENGTH,x,0)
       range\cpMax = x+y
       SendMessage_(*RichEditGadget,#EM_EXSETSEL,0,range)
       SendMessage_(*RichEditGadget,#EM_REPLACESEL,1,"")
       
       ResetList(CommentSelectionLine())
       For a = StartLine To EndLine
           NextElement(CommentSelectionLine())
           ;If Right(CommentSelectionLine(),1) <> Chr(11)
           ;   CommentSelectionLine()+Chr(11)
           ;EndIf
           RichEdit_InsertString(CommentSelectionLine(), #False)
           ; CommentSelectionLine() = ""
       Next a
       
       ClearList(CommentSelectionLine())
       
       ; small fix for removing the last added line ;)
       SendMessage_(*RichEditGadget,#WM_KEYDOWN,#VK_DELETE,0)
       SendMessage_(*RichEditGadget,#WM_KEYUP,#VK_DELETE,0)

       SendMessage_(*RichEditGadget, #WM_SETREDRAW, #True, 0) ; Enable the redraw again
       
       UpdateLineNumbering()
       UpdateProcedureList()
       
       InvalidateRect_(*RichEditGadget, 0, #True)
    EndIf
  EndIf
EndProcedure


Procedure UnCommentSelection()
  If *RichEditGadget
    SendMessage_(*RichEditGadget,#EM_EXGETSEL,0,selrange.CHARRANGE)
    If selrange\cpMin <> selrange\cpMax
       SendMessage_(*RichEditGadget, #WM_SETREDRAW, #False, 0) ; Disable the redraw on the RichEdit for clean effect

       StartLine   = SendMessage_(*RichEditGadget,#EM_EXLINEFROMCHAR,0,selrange\cpMin)
       EndLine     = SendMessage_(*RichEditGadget,#EM_EXLINEFROMCHAR,0,selrange\cpMax-1) ; -1 = fix, dont remove
       
       ;ClearList(CommentSelectionLine())
       For a = StartLine To EndLine
          *buffer.Byte = GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,64000)
          PokeW(*buffer,64000)
          Length = SendMessage_(*RichEditGadget,#EM_GETLINE,a,*buffer)
          PokeL(*buffer+length,0)
          AddElement(CommentSelectionLine())
          A$ = PeekS(*buffer,64000)
          length1 = Len(A$)
          B$ = LTrim(A$)
          length2 = Len(B$)
          
          If Asc(B$) = ';'
             B$ = Right(B$,length2-1)
             If Asc(B$) = 32 And DontRemoveSpace = 0
               CommentSelectionLine() = Space(length1-length2)+Right(B$,length2-2)
             ElseIf Asc(B$) = 45 ; Marker
               CommentSelectionLine() = A$
             Else
               CommentSelectionLine() = Space(length1-length2)+B$
               DontRemoveSpace = 1
             EndIf
          Else
             CommentSelectionLine() = A$
          EndIf
          GlobalFree_(*buffer)
       Next a

       range.CHARRANGE
       range\cpMin = SendMessage_(*RichEditGadget,#EM_LINEINDEX,StartLine,0)
       x = SendMessage_(*RichEditGadget,#EM_LINEINDEX,EndLine,0)
       y = SendMessage_(*RichEditGadget,#EM_LINELENGTH,x,0)
       range\cpMax = x+y
       SendMessage_(*RichEditGadget,#EM_EXSETSEL,0,range)
       SendMessage_(*RichEditGadget,#EM_REPLACESEL,1,"")
       
       ResetList(CommentSelectionLine())
       For a = StartLine To EndLine
           NextElement(CommentSelectionLine())
           RichEdit_InsertString(CommentSelectionLine(), #False)
           ; CommentSelectionLine() = ""
       Next a
       
       ClearList(CommentSelectionLine())
       
       ; small fix for removing the last added line ;)
       SendMessage_(*RichEditGadget,#WM_KEYDOWN,#VK_DELETE,0)
       SendMessage_(*RichEditGadget,#WM_KEYUP,#VK_DELETE,0)
       
       SendMessage_(*RichEditGadget, #WM_SETREDRAW, #True, 0) ; Enable the redraw again
       
       UpdateLineNumbering()
       UpdateProcedureList()
      
       InvalidateRect_(*RichEditGadget, 0, #True)       
    EndIf
  EndIf
EndProcedure
; ExecutableFormat=Windows
; UseMainFile=PureBasic IDE.pb
; DisableDebugger
; EOF